package com.qunzhixinxi.hnqz.admin.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.admin.entity.WmDaProject;
import com.qunzhixinxi.hnqz.admin.service.WmDaProjectService;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.log.annotation.SysLog;
import com.qunzhixinxi.hnqz.common.security.util.SecurityUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

/**
 * 档案-项目管理
 *
 * @author Liujh
 * @date 2020-12-8
 */
@RestController
@AllArgsConstructor
@RequestMapping("/wmdaproject")
@Api(value = "wmdaproject", tags = "档案-项目管理")
public class WmDaProjectController {
	private final WmDaProjectService wmDaProjectService;

	/**
	 * 查看项目管理信息
	 */
	@PostMapping("/selectProjects")
	public R selectProjects(@RequestBody WmDaProject wmDaProject) {
		try {
			return R.ok(wmDaProjectService.selectProjects(wmDaProject));
		} catch (Exception e) {
			e.printStackTrace();
			return R.failed();
		}
	}

	/**
	 * 分页查询项目管理信息
	 */
	@GetMapping("/selectWmDaProjectList")
	public R selectWmDaProjectList(Page page, WmDaProject wmDaProject) {
		try {
			return R.ok(wmDaProjectService.selectWmDaProjectList(page, wmDaProject));
		} catch (Exception e) {
			e.printStackTrace();
			return R.failed();
		}
	}

//	/**
//	 * 编辑项目管理信息
//	 */
//	@ApiOperation(value = "修改档案-项目管理", notes = "修改档案-项目管理")
//	@SysLog("修改档案-项目管理")
//	@PostMapping("updateWmDaProjectById")
//	public R updateWmDaProjectById(@RequestBody Map paramMap) {
//		Integer currentUserId = SecurityUtils.getUser().getId();//当前用户id
//		int projectId = wmDaProjectService.updatewmDaProjectById(paramMap,currentUserId);
//		if (projectId == -1) {
//			R.failed("缺少参数：ID");
//		} else if (projectId == -2) {
//			R.failed("未查询到该项目跟踪信息");
//		} else if (projectId == -3) {
//			R.failed("未查询到项目信息");
//		} else if (projectId == -4) {
//			R.failed("项目名称信息已存在");
//		}
//
//		return R.ok(projectId);
//	}

//	/**
//	 * 新增项目管理信息
//	 */
//	@ApiOperation(value = "新增档案-项目管理", notes = "新增档案-项目管理")
//	@SysLog("新增档案-项目管理")
//	@PostMapping("insertWmDaProject")
//	public R insertWmDaProject(@RequestBody Map paramMap) {
//		Integer currentUserId = SecurityUtils.getUser().getId();//当前用户id
//		int projectId = wmDaProjectService.insertWmDaProject(paramMap, currentUserId);
//
//		if (projectId == -1) {
//			R.failed("项目信息已经存在");
//		}
//
//		return R.ok(projectId);
//	}

	/**
	 * 编辑项目管理信息
	 */
	@ApiOperation(value = "修改档案-项目管理", notes = "修改档案-项目管理")
	@SysLog("修改档案-项目管理")
	@PostMapping("updateWmDaProjectsById")
	public R updateWmDaProjectsById(@RequestBody WmDaProject wmDaProject) {
		Integer currentUserId = SecurityUtils.getUser().getId();//当前用户id
		return wmDaProjectService.updateWmDaProjectsById(wmDaProject,currentUserId);
	}

	/**
	 * 新增项目管理信息
	 */
	@ApiOperation(value = "新增档案-项目管理", notes = "新增档案-项目管理")
	@SysLog("新增档案-项目管理")
	@PostMapping("insertWmDaProjects")
	public R<WmDaProject> insertWmDaProjects(@RequestBody WmDaProject wmDaProject) {
		Integer currentUserId = SecurityUtils.getUser().getId();//当前用户id
		return wmDaProjectService.insertWmDaProjects(wmDaProject, currentUserId);
	}
}
